#include <stdio.h>
#include <math.h>

#define NN 30

float a[NN];
float r;

float pow_2(float f, int n){
  unsigned long u1, u2, u3;
  
  u1 = *(unsigned long *)&f;
  u2 = u1 >> 23;
  u3 = u2 << 23;
  u1 -= u3;
  u2 += n;
  u2 = u2 << 23;
  u1 += u2;
  
  return *(float *)&u1;
}

void init(){
  int i;
  float f;
  
  r = 1.0;
  for(i = 0; i < NN; i++){
    a[i] = atan(pow_2(1.0, -i));
    r *= cos(a[i]);
    f = 2 * a[i];
  }
  f = 2 * r;
}

float cordic_atan(float t){
  int i;
  float x, y, z, tmp;
  
  x = 1.0;
  y = t;
  z = 0.0;
  for(i = 0; i < NN; i++){
    if(y > 0){
      tmp = x + pow_2(y, -i);
      y = -pow_2(x, -i) + y;
      x = tmp;
      z += a[i];
    }else if(y == 0)
      break;
    else{
      tmp = x - pow_2(y, -i);
      y = pow_2(x, -i) + y;
      x = tmp;
      z -= a[i];
    }
    printf("x=%f, y=%f, z=%f\n", x, y, z);
  }
  
  return z;
}

float cordic_sin_cos(int type, float theta){
  int i;
  float x, y, z, tmp;
  
  x = r;
  y = 0.0;
  z = 0.0;
  
  for(i = 0; i < NN; i++){
    if(z < theta){
      tmp = x - pow_2(y, -i);
      y = pow_2(x, -i) + y;
      x = tmp;
      z += a[i];
    }else{
      tmp = x + pow_2(y, -i);
      y = -pow_2(x, -i) + y;
      x = tmp;
      z -= a[i];
    }
    printf("x=%f, y=%f, z=%f\n", x, y, z);
  }
  
  return type ? x : y;
}

float sub_2pi(float x){
  unsigned long l, e;
  float y;
  
  x *= 2;
  l = *(unsigned long *)&x;
  x /= 2;
  e = l >> 23 & 0xFF;
  if(e < 0x82) return x;
  e -= 0x81;
  y = pow_2(M_PI, e);
  x -= y;
  return x;
}

float m_sin(float x){
  printf("m_sin begin.\n");
  while(4 < x){
    x = sub_2pi(x);
    printf("x = %.10e\n", x);
  }
  if(M_PI < x) x -= 2 * M_PI;
  if(x < 0) return -m_sin(-x);
  if(M_PI / 2 < x) x = M_PI - x;
  if(M_PI / 4 < x)
    return cordic_sin_cos(1, M_PI / 2 - x);
  else
    return cordic_sin_cos(0, x);
}

float m_cos(float x){
  printf("m_cos begin.\n");
hoge:
  while(4 < x){
    x = sub_2pi(x);
    printf("x = %.10e\n", x);
  }
  if(M_PI < x) x -= 2 * M_PI;
  if(x < 0){
    x = -x;
    goto hoge;
  }
  if(M_PI / 2 < x) return -m_cos(M_PI - x);
  if(M_PI / 4 < x)
    return cordic_sin_cos(0, M_PI / 2 -x);
  else
    return cordic_sin_cos(1, x);
}

int main(){
  int i;
  float f = 1.340021;
  double c = M_PI / (float)M_PI;
  init();
  
  printf("%.10e %.10e\n", m_sin(f), sin(f));
}
