use strict;

sub finv {
    my $addr = $_[0] << 1 & 0x3FE | 0x401;
    my $tbl = int(0x400000 / $addr) - int(0x200000 / $addr) & 0x3FF;
    $tbl;
}

sub fsqrtinv {
    my $addr = ($_[0] & 0x1FE | 0x201) << ($_[0] & 0x1);
    my $tbl = int(1 / sqrt($addr / 0x200) * 0x1000 + 0.5) >> 1 & 0x3FF;
    $tbl;
}

sub fsqrt {
    my $tbl = int(0x100000000 / (fsqrtinv($_[0]) | 0x400)) - int(0x80000000 / (fsqrtinv($_[0]) | 0x400)) - 1 & 0x0FFFFF;
    $tbl;
}


for my $high(0..0x1F) {
    printf "INIT_%02X => X\"", $high;
    for my $low (0..7) {
	my $tbl = finv($high << 4 | $low << 1 ^ 0xF) << 22
	    | finv($high << 4 | $low << 1 ^ 0xE) << 6
	    | fsqrt($high << 4 | $low << 1 & 0xC ^ 0xC | $low & 1 ^ 1) << 2 & 0x3F0000
	    | fsqrt($high << 4 | $low << 1 & 0xC ^ 0xC | $low & 1 ^ 1) >> 8 & 0x3F;
	    printf "%08X", $tbl;
    }
    printf "\",\n";
}
for my $high(0..0x1F) {
    printf "INIT_%02X => X\"", $high + 0x20;
    for my $low (0..7) {
	my $tbl = fsqrtinv($high << 4 | $low << 1 ^ 0xF) << 22
	    | fsqrtinv($high << 4 | $low << 1 ^ 0xE) << 6
	    | fsqrt($high << 4 | $low << 1 ^ 0xF) << 14 & 0x3F0000
	    | fsqrt($high << 4 | $low << 1 ^ 0xE) >> 2 & 0x3F;
	    printf "%08X", $tbl;
    }
    printf "\",\n";
}
for my $high(0..3) {
    printf "INITP_%02X => X\"", $high;
    for my $low (0..0x3F) {
	my $tbl = (fsqrt($high << 7 | $low << 1 & 0x7C ^ 0x7C | 2 | $low & 1 ^ 1) >> 8) - (fsqrt(($high << 7 | $low << 1 & 0x7C ^ 0x7C | $low & 1 ^ 1)) >> 8) - 1;
	    printf "%01X", $tbl;
    }
    printf "\",\n";
}
for my $high(0..3) {
    printf "INITP_%02X => X\"", $high + 0x4;
    for my $low (0..0x3F) {
	my $tbl = fsqrt($high << 7 | $low << 1 ^ 0x7F) << 2 & 0xc
	    | fsqrt($high << 7 | $low << 1 ^ 0x7E) & 0x3;
	    printf "%01X", $tbl;
    }
    printf "\",\n";
}
my ($old, $new);
for my $high(0..0x1F) {
    for my $low (0..15) {
	(my $tbl) = fsqrt($high << 5 & 0x1FF | $low << 1 | $high >> 4);
	($old, $new) = ($new, $tbl >> 8);
	if ($low % 2) {
	    #printf "%03X %01X | \n", $old, $new - $old;	
	}
    }
}
