#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <memory.h>
#include <string.h>

const char *F = "%f";
const char *L = "%ld";
const char *B = "%c";
const char *H = "%02X\n";

static unsigned long process(char *out, char *in) {
  unsigned long param;
  if (scanf(in, &param) == 1) {
    printf(out, param & 0xFF);
    printf(out, param >> 8 & 0xFF);
    printf(out, param >> 16 & 0xFF);
    printf(out, param >> 24);
    return param;
  } else {
    return 0xFFFFFFFF;
  }
}

static void vec3(char *out)
{
  process(out, F);
  process(out, F);
  process(out, F);
}

static void sld_env(char *out) {
  // screen pos
  vec3(out);
  // screen rotation
  process(out, F); process(out, F); 
  // n_lights : Actually, it should be an int value !
  process(out, F);
  // light rotation
  process(out, F); process(out, F);
  // beam  
  process(out, F);
}

static void objects(char *out)
{
  while (process(out, L) != -1) {
    // form
    process(out, L);
    // refltype
    process(out, L);
    // isrot_p
    long is_rot = process(out, L);
    // abc
    vec3(out);
    // xyz
    vec3(out);
    // is_invert
    process(out, F);
    // refl_param
    process(out, F); process(out, F);
    // color
    vec3(out);
    // rot
    if(is_rot) vec3(out);
  }
}

static void and_network(char *out)
{
  while(process(out, L) != -1){
    while(process(out, L) != -1);
  }
}

static void or_network(char *out)
{
  while(process(out, L) != -1){
    while(process(out, L) != -1);
  }
}

static void sld(char *out)
{
  sld_env(out);
  objects(out);
  and_network(out);
  or_network(out);
}

//-----------------------------------------------------------------------------
// main
int main(int argc, char* argv[]) {  
  if (argc == 2 && !strcmp(argv[1], "-h")) sld(H);
  else sld(B);
  return 0;
}

