
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:44:33 11/16/2005
-- Design Name:   cpu
-- Module Name:   cpu_test.vhd
-- Project Name:  cpu
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: cpu
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

use std.textio.all;
use ieee.std_logic_textio.all;

ENTITY cpu_test IS
END cpu_test;

ARCHITECTURE behavior OF cpu_test IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT cpu
	PORT(
		CLK : IN std_logic;    
		IOA : INOUT std_logic_vector(31 downto 0);      
		LED : OUT std_logic_vector(7 downto 0);
		AA : OUT std_logic_vector(19 downto 0);
		ADVLDA : OUT std_logic;
		XRWA : OUT std_logic;
		CEA : OUT std_logic;
		BWA : OUT std_logic_vector(3 downto 0);
		CELA1X : OUT std_logic;
		CEHA1X : OUT std_logic;
		CEA2X : OUT std_logic;
		CEA2 : OUT std_logic;
		CLKMA0 : OUT std_logic;
		CLKMA1 : OUT std_logic;
		LBOA : OUT std_logic;
		OEAX : OUT std_logic;
		ZZA : OUT std_logic;
                USBD : INOUT std_logic_vector(7 downto 0);
                USBRDX : OUT std_logic;
                USBWR : OUT std_logic;
                USBTXEX : IN std_logic;
                USBRXFX : IN std_logic;
                USBRSTX : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL CLK :  std_logic := '0';

	--BiDirs
	SIGNAL IOA :  std_logic_vector(31 downto 0);

	--Outputs
	SIGNAL LED :  std_logic_vector(7 downto 0);
	SIGNAL AA :  std_logic_vector(19 downto 0);
	SIGNAL ADVLDA :  std_logic;
	SIGNAL XRWA :  std_logic;
	SIGNAL CEA :  std_logic;
	SIGNAL BWA :  std_logic_vector(3 downto 0);
	SIGNAL CELA1X :  std_logic;
	SIGNAL CEHA1X :  std_logic;
	SIGNAL CEA2X :  std_logic;
	SIGNAL CEA2 :  std_logic;
	SIGNAL CLKMA0 :  std_logic;
	SIGNAL CLKMA1 :  std_logic;
	SIGNAL LBOA :  std_logic;
	SIGNAL OEAX :  std_logic;
	SIGNAL ZZA :  std_logic;
        SIGNAL USBD :  std_logic_vector(7 downto 0);
        SIGNAL USBRDX :  std_logic;
        SIGNAL USBWR :  std_logic;
        SIGNAL USBTXEX :  std_logic;
        SIGNAL USBRXFX :  std_logic;
        SIGNAL USBRSTX :  std_logic;
        
        file hp_mem : text is in "./heap.mem";
        file hp_log : text is out "./heap.log";
        file sm_in : text is in "./stream.in";
        file sm_out : text is out "./stream.out";
        
BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: cpu PORT MAP(
		CLK => CLK,
		LED => LED,
		AA => AA,
		ADVLDA => ADVLDA,
		XRWA => XRWA,
		CEA => CEA,
		BWA => BWA,
		CELA1X => CELA1X,
		CEHA1X => CEHA1X,
		CEA2X => CEA2X,
		CEA2 => CEA2,
		CLKMA0 => CLKMA0,
		CLKMA1 => CLKMA1,
		IOA => IOA,
		LBOA => LBOA,
		OEAX => OEAX,
		ZZA => ZZA, 
                USBD => USBD,
                USBRDX => USBRDX,
                USBWR => USBWR,
                USBTXEX => USBTXEX,
                USBRXFX => USBRXFX,
                USBRSTX => USBRSTX       
	);

	tb : PROCESS
          constant period : time := 20 ns;
	BEGIN
          loop
            CLK <= '1';
            wait for period / 2;
            CLK <= '0';
            wait for period / 2;
          end loop;
          wait;          
	END PROCESS;

        process (CLKMA0) 
          variable init : boolean := true;
          variable hp_method : std_logic_vector(1 downto 0);
          type hp_address_t is array (1 downto 0) of std_logic_vector(19 downto 0);
          variable hp_address : hp_address_t;
          type hp_reg_t is array (2 ** 20 - 1 downto 0) of std_logic_vector(31 downto 0);
          variable hp_reg : hp_reg_t;
          variable ln : line;
        begin
          if init then
            for i in 0 to 2 ** 20 - 1 loop
              exit when endfile(hp_mem);
              readline(hp_mem, ln);
              hread(ln, hp_reg(i));
            end loop;  -- i
            init := not init;
          end if;
          if CLKMA0'event and CLKMA0 = '0' then  -- falling clock edge
            if hp_method(1) = '0' then
              IOA <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
            else
              IOA <= hp_reg(conv_integer(hp_address(1)));
            end if;
          elsif CLKMA0'event and CLKMA0 = '1' then  -- rising clock edge
            if hp_method(1) = '0' then              
              hp_reg(conv_integer(hp_address(1))) := IOA;
              write(ln, conv_integer(hp_address(1)));
              write(ln, ' ');
              hwrite(ln, IOA);
              writeline(hp_log, ln);
            end if;               
            hp_address := hp_address(0) & AA;
            hp_method := hp_method(0) & XRWA;
          end if;
        end process;

        USBRXFX <= '1' when endfile(sm_in) else
                   '0';

        process (USBRDX, USBRSTX)
          variable ln : line;
          variable octet : std_logic_vector(7 downto 0);
        begin  -- process
          if USBRSTX = '0' then         -- asynchronous reset (active low)
            USBD <= "ZZZZZZZZ";                        
          elsif USBRDX'event and USBRDX = '0' then  -- falling clock edge
            readline(sm_in, ln);
            hread(ln, octet);
            USBD <= octet;
          elsif USBRDX'event and USBRDX = '1' then  -- rising clock edge
            USBD <= "ZZZZZZZZ";            
          end if;
        end process;

        USBTXEX <= '0';        

        process (USBWR, USBRSTX)
          variable ln : line;
          variable octet : std_logic_vector(7 downto 0);
        begin  -- process
          if USBRSTX = '0' then         -- asynchronous reset (active low)
            
          elsif USBWR'event and USBWR = '0' then  -- falling clock edge
            octet := USBD;
            hwrite(ln, octet);
            writeline(sm_out, ln);
          end if;
        end process;

END;
