--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    11:15:18 01/23/06
-- Design Name:    
-- Module Name:    calculator - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_SIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity calculator is
  port (
    FNCT     : in  std_logic_vector(2 downto 0);
    RDX, RDY : in  std_logic_vector(31 downto 0);
    FA       : in  std_logic_vector(19 downto 0);
    WD0      : out std_logic_vector(31 downto 0);
    BA       : out std_logic_vector(19 downto 0);
    OFTD     : in  std_logic_vector(15 downto 0);
    OFTS     : in  std_logic;
    CNTS     : in  std_logic);
end calculator;

architecture Behavioral of calculator is

  signal DX, DY, D, A : std_logic_vector(31 downto 0);

begin

  with CNTS select
    DX <=
    RDX                                when '0',
    sxt(FA, 32)                        when '1',
    "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" when others;
  
  with OFTS select
    DY <=
    RDY                                when '0',
    sxt(OFTD, 32)                      when '1',
    "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" when others;
  with FNCT(0) select
    A <=
    DX + DY                            when '0',
    DX - DY                            when '1',
    "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" when others;  

  BA <= A(19 downto 0);

  with FNCT select
    D <=
    A                                  when "000",
    A                                  when "001",
    shl(RDX, OFTD(8 downto 4))         when "010",
    shr(RDX, OFTD(8 downto 4))         when "011",
    RDX and RDY                        when "100",
    RDX or RDY                         when "101",
    RDX xor RDY                        when "110",
    RDX xnor RDY                       when "111",
    "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" when others;

  with CNTS select
    WD0 <=
    D                                  when '0',
    ext(FA, 32)                        when '1',
    "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" when others;  

end Behavioral;
