--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    10:58:54 01/28/06
-- Design Name:    
-- Module Name:    comparator - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity comparator is
  port (
    CND      : in  std_logic_vector(2 downto 0);
    RDX, RDY : in  std_logic_vector(31 downto 0);
    BS       : out std_logic;
    CS       : out std_logic;
    OPTD     : in  std_logic_vector(5 downto 0);
    OPTS     : in  std_logic);
end comparator;

architecture Behavioral of comparator is

  signal D : std_logic_vector(31 downto 0);
  signal EQ, LS : std_logic;
  signal S : std_logic;

begin

  with OPTS select
    D <=
    RDY                                when '0',
    sxt(OPTD, 32)                      when '1',
    "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" when others;

  EQ <= '1' when RDX(30 downto 0) = D(30 downto 0) else '0';
  LS <= '1' when RDX(30 downto 0) < D(30 downto 0) else '0';

  with CND(2 downto 1) select
    S <=
    (RDX(31) xnor D(31)) and EQ                                                when "00",
    ((RDX(31) or not D(31)) and LS) or (not RDX(31) and D(31))                 when "01",
    (RDX(31) and LS) or (not D(31) and (EQ nor LS)) or (not RDX(31) and D(31)) when "10",
    '1'                                                                        when "11",
    'X'                                                                        when others;

  CS <= LS;
  BS <= S xor CND(0);    

end Behavioral;
