--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    13:12:10 02/03/06
-- Design Name:    
-- Module Name:    loader - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity loader is
  port (
    CLK    : in    std_logic;
    LOCKED : in    std_logic;
    LE     : in    std_logic;
    TE     : in    std_logic;
    LA     : in    std_logic_vector(19 downto 0);
    WD1    : out   std_logic_vector(31 downto 0);
    WD4    : out   std_logic_vector(31 downto 0);
    RD     : in    std_logic_vector(31 downto 0);
    XRWA   : out   std_logic;
    IOA    : inout std_logic_vector (31 downto 0));
end loader;

architecture Behavioral of loader is

  signal E : std_logic_vector (1 downto 0);
  signal D : std_logic_vector (63 downto 0);
  type ram_type is array (8191 downto 0) of std_logic_vector(31 downto 0);
  signal RAM : ram_type;

begin

  XRWA <= not E(0);
  
  process (CLK, LOCKED)
  begin  -- process
    if LOCKED = '0' then                -- asynchronous reset (active low)
      E <= "00";
      D <= "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
      IOA <= "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
    elsif CLK'event and CLK = '1' then  -- rising clock edge
      E <= E(0) & TE;
      D <= D(31 downto 0) & RD;
      if E(1) = '1' then
        IOA <= D(63 downto 32);
      else
        IOA <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
      end if;
      WD4 <= IOA;    
    end if;
  end process;

--  process (CLK)
--  begin  -- process
--    if CLK'event and CLK = '1' then     -- rising clock edge
--      if LE = '1' then
--        if TE = '1' then
--          RAM(conv_integer(LA(12 downto 0))) <= TD;
--        end if;
--        LD <= RAM(conv_integer(LA(12 downto 0)));        
--      end if;
--    end if;
--  end process;


end Behavioral;
