
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:44:33 11/16/2005
-- Design Name:   processor
-- Module Name:   processor_test.vhd
-- Project Name:  processor2x
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: cpu
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

use std.textio.all;
use ieee.std_logic_textio.all;

ENTITY tester IS
END tester;

ARCHITECTURE behavior OF tester IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT processor
	PORT(
		CLK : IN std_logic;    
		LED : OUT std_logic_vector(7 downto 0);
		AA : OUT std_logic_vector(19 downto 0);
		ADVLDA : OUT std_logic;
		XRWA : OUT std_logic;
		CEA : OUT std_logic;
		BWA : OUT std_logic_vector(3 downto 0);
		CELA1X : OUT std_logic;
		CEHA1X : OUT std_logic;
		CEA2X : OUT std_logic;
		CEA2 : OUT std_logic;
		CLKMA0 : OUT std_logic;
		CLKMA1 : OUT std_logic;
		IOA : INOUT std_logic_vector(31 downto 0);      
		LBOA : OUT std_logic;
		OEAX : OUT std_logic;
		ZZA : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL CLK :  std_logic := '0';

	--BiDirs
	SIGNAL IOA :  std_logic_vector(31 downto 0);

	--Outputs
	SIGNAL LED :  std_logic_vector(7 downto 0);
	SIGNAL AA :  std_logic_vector(19 downto 0);
	SIGNAL ADVLDA :  std_logic;
	SIGNAL XRWA :  std_logic;
	SIGNAL CEA :  std_logic;
	SIGNAL BWA :  std_logic_vector(3 downto 0);
	SIGNAL CELA1X :  std_logic;
	SIGNAL CEHA1X :  std_logic;
	SIGNAL CEA2X :  std_logic;
	SIGNAL CEA2 :  std_logic;
	SIGNAL CLKMA0 :  std_logic;
	SIGNAL CLKMA1 :  std_logic;
	SIGNAL LBOA :  std_logic;
	SIGNAL OEAX :  std_logic;
	SIGNAL ZZA :  std_logic;
        
        file mem : text is in "./processor.mem";
        file log : text is out "./processor.log";
--        file sm_in : text is in "./stream.in";
--        file sm_out : text is out "./stream.out";
        
BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: processor PORT MAP(
		CLK => CLK,
		LED => LED,
		AA => AA,
		ADVLDA => ADVLDA,
		XRWA => XRWA,
		CEA => CEA,
		BWA => BWA,
		CELA1X => CELA1X,
		CEHA1X => CEHA1X,
		CEA2X => CEA2X,
		CEA2 => CEA2,
		CLKMA0 => CLKMA0,
		CLKMA1 => CLKMA1,
		IOA => IOA,
		LBOA => LBOA,
		OEAX => OEAX,
		ZZA => ZZA
	);

	tb : PROCESS
          constant PERIOD : time := 20 ns;
	BEGIN
          loop
            CLK <= '1';
            wait for PERIOD / 2;
            CLK <= '0';
            wait for PERIOD / 2;
          end loop;
          wait;          
	END PROCESS;

        process
          variable E : std_logic_vector(1 downto 0);
          variable A : std_logic_vector (39 downto 0);
          type sram_type is array (2 ** 20 - 1 downto 0) of std_logic_vector(31 downto 0);
          variable SRAM : sram_type;
          variable ln : line;
        begin
          for i in 0 to 2 ** 20 - 1 loop
            exit when endfile(mem);
            readline(mem, ln);
            hread(ln, SRAM(i));
          end loop;  -- i
          loop 
            wait until CLKMA0'event and CLKMA0 = '1';
            if E(1) = '0' then
              SRAM(conv_integer(A(39 downto 20))) := IOA;
              write(ln, conv_integer(A(39 downto 20)));
              write(ln, ' ');
              hwrite(ln, IOA);
              writeline(log, ln);
            end if;
            A := A(19 downto 0) & AA;
            E := E(0) & XRWA;
            wait until CLKMA0'event and CLKMA0 = '0';
            if E(1) = '0' then
              IOA <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
            else
              IOA <= SRAM(conv_integer(A(39 downto 20)));
            end if;
          end loop;
          wait;
        end process;

--        process (CLKMA0)
--          variable E : std_logic_vector(1 downto 0);
--          variable A : std_logic_vector (39 downto 0);
--          type sram_type is array (2 ** 20 - 1 downto 0) of std_logic_vector(31 downto 0);
--          variable SRAM : sram_type;
--          variable ln : line;
--          variable init : boolean := true;
--        begin
--          if init then
--            for i in 0 to 2 ** 20 - 1 loop
--              exit when endfile(mem);
--              readline(mem, ln);
--              hread(ln, SRAM(i));
--            end loop;  -- i
--            init := not init;
--          end if;
--          if CLKMA0'event and CLKMA0 = '0' then  -- falling clock edge
--            if E(1) = '0' then
--              IOA <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
--            else
--              IOA <= SRAM(conv_integer(A(39 downto 20)));
--            end if;
--          elsif CLKMA0'event and CLKMA0 = '1' then  -- rising clock edge
--            if E(1) = '0' then
--              SRAM(conv_integer(A(39 downto 20))) := IOA;
--              write(ln, conv_integer(A(39 downto 20)));
--              write(ln, ' ');
--              hwrite(ln, IOA);
--              writeline(log, ln);
--            end if;
--            A := A(19 downto 0) & AA;
--            E := E(0) & XRWA;
--          end if;
--        end process;
        
--        USBRXFX <= '1' when endfile(sm_in) else
--                   '0';

--        process (USBRDX, USBRSTX)
--          variable ln : line;
--          variable octet : std_logic_vector(7 downto 0);
--        begin  -- process
--          if USBRSTX = '0' then         -- asynchronous reset (active low)
--            USBD <= "ZZZZZZZZ";                        
--          elsif USBRDX'event and USBRDX = '0' then  -- falling clock edge
--            readline(sm_in, ln);
--            hread(ln, octet);
--            USBD <= octet;
--          elsif USBRDX'event and USBRDX = '1' then  -- rising clock edge
--            USBD <= "ZZZZZZZZ";            
--          end if;
--        end process;

--        USBTXEX <= '0';        

--        process (USBWR, USBRSTX)
--          variable ln : line;
--          variable octet : std_logic_vector(7 downto 0);
--        begin  -- process
--          if USBRSTX = '0' then         -- asynchronous reset (active low)
            
--          elsif USBWR'event and USBWR = '0' then  -- falling clock edge
--            octet := USBD;
--            hwrite(ln, octet);
--            writeline(sm_out, ln);
--          end if;
--        end process;

END;
